import java.util.HashMap;
import java.util.Map;

import org.dom4j.Document;

import com.justep.system.process.*;
import com.justep.system.context.*;
import com.justep.system.data.BizData;
import com.justep.system.data.KSQL;
import com.justep.system.data.Table;
import com.justep.system.opm.*;

public class Master {

	public static void c2AfterAdvance() {
		//获取新任务的id
		Document doc = (Document) ContextHelper.getActionContext().getActionResult();
		String task = doc.selectSingleNode("/items/item/task").getText();

		//继续批转,到等待环节
		ProcessControl control = ProcessUtils.advanceProcessQuery(task);
		ProcessControlItem item = control.getFlowTos().get(0);
		item.clearExecutors();
		//指定相同的执行者
		ProcessControlItem c3item = ProcessUtils.getProcessContext().getProcessControl().getFlowTo("c3");
		for (OrgUnit ou : c3item.getExecutors()) {
			item.addExecutor(ou);
		}
		//批转
		ProcessUtils.advanceProcess(task, control);
	}

	public static void c3AfterAdvance() {
		//获取新任务的id
		Document doc = (Document) ContextHelper.getActionContext().getActionResult();
		String task = doc.selectSingleNode("/items/item/task").getText();

		//方法1，通过创建任务完成任务转移
		//产生C3流程的入口任务,通过任务的sData1传递当前暂停任务的id,执行人同主流程的执行人
		/*
		ProcessControlItem item = ProcessUtils.getProcessContext().getProcessControl().getFlowTos().get(0);
		Task t = TaskHelper.createTask("创建启动C3的功能任务", "/demo/components/process/c3/c3Process", "c3Activity", "/demo/components/process/c3/c3Activity.w",
				"/demo/components/process/c3/c3Activity.w", task, item.getExecutors(), null);
		t.save();
		*/
		
		//方法2，直接产生业务数据，启动C3流程
		ProcessControlItem mitem = ProcessUtils.getProcessContext().getProcessControl().getFlowTos().get(0);
		Table t = KSQL.select("select DEMO_TABLE3.* from DEMO_TABLE3 DEMO_TABLE3 where 1 = 2", null, "/demo/components/data", null);
		t = BizData.create(t, "DEMO_TABLE3", null, null);//产生业务数据
		t.save("/demo/components/data");
		String sData1 = t.iterator().next().getString("DEMO_TABLE3");
		
		ProcessControl control = ProcessUtils.startProcessQuery("/demo/components/process/c3/c3Process", null, null);
		ProcessControlItem item = control.getFlowTos().get(0);
		item.setSelected(true);
		item.clearExecutors();
		for (OrgUnit ou : mitem.getExecutors()) {
			item.addExecutor(ou);
		}
		Map<String, Object> relations = new HashMap<String, Object>();
		relations.put("sName", "C3启动-主流程触发");
		relations.put("sData1", sData1);//写入关联业务数据的id
		relations.put("sData2", task);//写入暂停的任务数据
		ProcessUtils.startProcess("/demo/components/process/c3/c3Process", relations, control, null, null);

		//暂停下一个任务
		ProcessUtils.suspendProcess(task, null);
	}

	public static void c2BeforeAdvance() {
	}
}