package com.justep.demo;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

import org.dom4j.Document;

import com.justep.system.action.ActionUtils;
import com.justep.system.context.ActionContext;
import com.justep.system.context.ContextHelper;
import com.justep.system.data.KSQL;
import com.justep.system.data.Table;
import com.justep.system.opm.OrgUnit;
import com.justep.system.process.ProcessConstants;
import com.justep.system.process.ProcessControl;
import com.justep.system.process.ProcessControlItem;
import com.justep.system.process.ProcessUtils;
import com.justep.system.process.Task;
import com.justep.system.process.TaskStatus;
import com.justep.system.util.CommonUtils;

public class DemoUtils {
	public static String SYSTEM_MODEL = "/system/data";
	
	//根据任务ID获取相关的业务数据
	/*
	 * 还有一种方式在主流程上存放每个子流程的sData1，这样可以直接使用表达式函数获取相关的值
	 */
	public static Table getData(Task t, String concept, String dataModel){
		return getData(t.getId(), concept, dataModel);
	}
	
	//根据任务ID获取相关的业务数据
	public static Table getData(String tid, String concept, String dataModel){
		Table table = KSQL.select("select A.sData1 as sData1 from SA_Task A " 
				+ " where A = '" + tid + "'", null, SYSTEM_MODEL, null);

		if (table.iterator().hasNext()){ 
			String sData1 = table.iterator().next().getString("sData1");
			return KSQL.select("select A.* as sData1 from "+concept+" A " 
					+ " where A = '" + sData1 + "'", null, dataModel, null);
		}else return null;
	}
	
	public static void startMasterProcess(String masterProcess, String masterActivity) {
		ActionContext context = ActionUtils.getRequestContext().getActionContext();
		Map<String, Object> relas = (Map<String, Object>) context.getParameter(ProcessConstants.PI_RELATION_VALUE_PARAMETER);
		//启动主流程
		String sData1 = CommonUtils.createGUID();
		String sData2 = null;
		if(null!=relas) sData2 = (String)relas.get("sData1");//把当前的sData1存到主流程的sData2
		
		ProcessControl control = ProcessUtils.startProcessQuery(masterProcess, null, null);
		for(ProcessControlItem item : control.getFlowTos()){
			if(!masterActivity.equals(item.getUnit()))
				control.removeFlowTo(item);//清除多余流转
		}
		ProcessControlItem item = control.getFlowTo(masterActivity);
		item.setSelected(true);
		item.clearExecutors();
		item.addExecutor(new OrgUnit(ContextHelper.getPersonMember().getFID(), ContextHelper.getPersonMember().getFName()));
		Map<String, Object> relations = new HashMap<String, Object>();
		relations.put("sName", "主流程启动-"+masterActivity+"触发");
		relations.put("sData1", sData1);
		relations.put("sData2", sData2);
		Document doc = ProcessUtils.startProcess(masterProcess, relations, control, new ArrayList<String>(), null);
		String task = doc.selectSingleNode("/items/item/task").getText();
		
		//子流程写入主流程任务，用于唤醒
		if(null!=relas){
			relas.put("sData2", task);//记录主流程的任务id
		}
		
		//暂停主流程
		ProcessUtils.suspendProcess(task, null);
	}

	public static void resumeMasterProcess(){
		Task task = ProcessUtils.getTaskInProcessContext();
		//根据sData2唤醒主流程
		if(null!=task){
			String task_sData2 = task.getData2();//记录主流程的任务id
			ProcessUtils.resumeProcess(task_sData2);
		}
	}
}
